/*
    Copyright (C) 1996,99  Marian Krivos
	nezmar@internet.alcatel.sk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    _fastgl.h - internal declarations

*/

#define VERZIA "1.41"

#ifdef __cplusplus
extern "C" {
#endif

#ifdef __linux__

#include <vga.h>
#include <vgakeyboard.h>
#include <vgamouse.h>

#endif

enum Drivers { FG_VESA, FG_CIRRUS, FG_TRIDENT, FG_S3, FG_S3V2,
	FG_MX, FG_TSENG3, FG_ATI, FG_TSENG4, FG_CHIPS,
	FG_WDIGITAL, FG_BANSHEE, FG_NVIDIA, FG_MATROX, FG_PERMEDIA,
	FG_INTEL,
FG_LAST};

void XWaitRetrace(void);
void XWaitPeriod(void);
extern const unsigned int _default_palette[256];
extern unsigned int _fgl_palette[256];

#if (defined(__linux__) || (defined(__GNUC__) && defined(__QNX__)))
extern int granularity asm("_granularity");
extern char * videobase asm("_videobase");
extern unsigned videobasesegment asm("_videobasesegment");
extern unsigned VideoSelector asm("_VideoSelector");
void set_palet1(int cnt, int ind, int *pal) asm("_set_palet1");
extern int cx_work asm("_cx_work"),
	cy_work asm("_cy_work"),
    cx_maxwork asm("_cx_maxwork"),
    cy_maxwork asm("_cy_maxwork"),
    ppop asm("_ppop"),
    lfb asm("_lfb");
extern void	_degraduj(char *, char *,char *,int) asm("__degraduj");
extern int  mmx_state asm("_mmx_state"), mmx asm("_mmx");
extern int _CurrBkColor asm("__CurrBkColor"),_CurrColor asm("__CurrColor");
extern int clip_x_min asm("_clip_x_min"), clip_y_min asm("_clip_y_min"), clip_x_max asm("_clip_x_max"), clip_y_max asm("_clip_y_max");
extern char miro0406x[] asm("_miro0406x"),  miro0808x[] asm("_miro0808x"), miro0816x[] asm("_miro0816x"), miro1220x[] asm("_miro1220x"), miro1625x[] asm("_miro1625x");
extern unsigned char miro0406[] asm("_miro0406"), miro0808[] asm("_miro0808"), miro0816[] asm("_miro0816"), miro1220[] asm("_miro1220"),  miro1625[] asm("_miro1625");
extern char _internal_bitmap0[] asm ("__internal_bitmap0");
extern int driver asm("_driver");
extern int cx_max asm("_cx_max"), cy_max asm("_cy_max");
extern char * Image asm("_Image"), *font asm("_font"), *cmaxaddr;
void _paletter(unsigned , unsigned int) asm("__paletter");
extern short _setvideomode(short) asm("__setvideomode");
extern void _fill_rect(int x,int y,int w,int h) asm("__fill_rect");
extern void TextClip(int x,int y,char *s) asm("_TextClip");
extern int framebuffer,	memorysize, lfb;
extern int GraphMode; /* maximalne rozlisenie */

#else

extern int granularity;
extern char * videobase;
extern unsigned videobasesegment;
extern unsigned VideoSelector;
void set_palet1(int cnt, int ind, int *pal);
extern int cx_work,
	cy_work,
    cx_maxwork,
    cy_maxwork,
    ppop;
extern void	_degraduj(char *,char *,char *, int);
extern int  mmx_state, mmx;
extern int _CurrBkColor,_CurrColor;
extern int clip_x_min, clip_y_min, clip_x_max, clip_y_max;
extern char miro0406x[],  miro0808x[], miro0816x[], miro1220x[], miro1625x[];
extern char _internal_bitmap0[];
extern int driver;
extern int cx_max, cy_max;
extern char * Image, *font, *cmaxaddr;
void PaletteInit(void);
void _palette(unsigned , unsigned int);
void _paletter(unsigned, unsigned int);
extern short _setvideomode(short);
extern void _fill_rect(int x,int y,int w,int h);
extern void TextClip(int x,int y,char *s);
extern int framebuffer,	memorysize, lfb;
extern int X_max, Y_max, GraphMode; /* maximalne rozlisenie */
#endif

void CloseUserInput(void);
void GetModeSize(int mode, int *m);
void set_linear(int);
extern int detect_video(int v);
extern int peek(short seg, unsigned off);
extern void poke(short seg, unsigned off, unsigned int value);
extern int MOVEABLE,inGraph;
extern int verbose;
extern char m_save[256],
m_mask[256],
m_mask2[256],
m_mask3[256],
m_mask4[256],
l_mask[256],
l_bmap[256],
m_bmap[256],
m_mask4b[256],
m_mask2b[256],
m_mask3b[256],
c_mask[196],
d_mask[196],
e_mask[196],
f_mask[196];

void WarningBeep(int which);
void Boxw(int x, int y, int w, int h);
void Textw(int x, int y, char *);
extern void Rectw(int x,int y,int w,int h);

extern void Hline(int x,int y,int c);
extern void Vline(int x,int y,int c);
extern unsigned int areasize(int x, int y);

const char *GetDriverName(void);

#if (defined(__linux__) || (defined(__GNUC__) && defined(__QNX__)))
void L1VideoToRam8(char	*, char	*, int,	int, int, int) asm("_L1VideoToRam8");
void L1RamToVideo2(char	*, char	*, int,	int, int, int) asm("_L1RamToVideo2");
void L1RamToVideo8(char	*, char	*, int,	int, int, int) asm("_L1RamToVideo8");
void L1RamToRam(char *,	char *,	int, int, int, int)	asm("_L1RamToRam");
void L1RamToRamPpop(char *,	char *,	int, int, int, int)	asm("_L1RamToRamPpop");
void L1Box(char	*, int,	int, int) asm("_L1Box");
void L1BoxX(char *,	int, int, int) asm("_L1BoxX");
void CharOutClip(char *, char *, int offset) asm("_CharOutClip");
void CharOutClip2(char *, char *, int offset) asm("_CharOutClip2");
#else
void L1VideoToRam8(char	*, char	*, int,	int, int, int);
void L1RamToVideo2(char	*, char	*, int,	int, int, int);
void L1RamToVideo8(char	*, char	*, int,	int, int, int);
void L1RamToRam(char *,	char *,	int, int, int, int);
void L1RamToRamPpop(char *,	char *,	int, int, int, int);
void L1Box(char	*, int,	int, int);
void L1BoxX(char *,	int, int, int);
void CharOutClip(char *, char *, int offset);
void CharOutClip2(char *, char *, int offset);
#endif

#define PICTOSIZE		20
#define TITLEH			20
#define BASEBORDER		4
#define MENUH			19
#define STATUSBARH		19

#define BORD1    		CScheme->wnd_bord1
#define BORD2			CScheme->wnd_bord2
#define BORD3			CScheme->wnd_bord3

#define CTITLE   		CScheme->inactive_title 	// color of unactive title
#define CTITLEACTIVE 	CScheme->active_title	 	// color of active title
#define MENUBG	 		CScheme->menu_back

#ifdef __WATCOMC__
#pragma aux set_palet1 "_*"
#pragma aux miro0406 "_*"
#pragma aux miro0808 "_*"
#pragma aux miro0816 "_*"
#pragma aux miro1220 "_*"
#pragma aux miro1625 "_*"
#pragma aux miro0406x "_*"
#pragma aux miro0808x "_*"
#pragma aux miro0816x "_*"
#pragma aux miro1220x "_*"
#pragma aux miro1625x "_*"
#pragma aux font "_*"
#pragma aux _setvideomode "_*"
#pragma aux granularity "_*"
#pragma aux lfb "_*"
#pragma aux videobase "_*"
#pragma aux videobasesegment "_*"
#pragma aux VideoSelector "_*"
#pragma aux peek "_*"
#pragma aux poke "_*"
#pragma aux driver "_*"
#pragma aux PaletteInit "_*"
#pragma aux mmx "_*"
#pragma aux ppop "_*"
#pragma aux mmx_state "_*"
#pragma aux _fill_rect "_*"
#pragma aux __dpmi_int "_*"
#pragma aux _CurrBkColor "_*"
#pragma aux _CurrColor "_*"
#pragma aux cx_max "_*"
#pragma aux cy_max "_*"
#pragma aux cx_maxwork "_*"
#pragma aux cy_maxwork "_*"
#pragma aux cx_work "_*"
#pragma aux cy_work "_*"
#pragma aux Image "_*"
#pragma aux CharOutClip "_*"
#pragma aux CharOutClip2 "_*"
#pragma aux clip_x_min "_*"
#pragma aux clip_y_min "_*"
#pragma aux clip_x_max "_*"
#pragma aux clip_y_max "_*"
#pragma aux L1Box "_*"
#pragma aux L1BoxX "_*"
#pragma aux L1RamToRam "_*"
#pragma aux L1RamToRamPpop "_*"
#pragma aux L1RamToVideo2 "_*"
#pragma aux L1RamToVideo8 "_*"
#pragma aux L1VideoToRam8 "_*"
#pragma aux _degraduj "_*"
#endif

#ifdef __cplusplus
}
#endif

#ifdef __linux__

#include "linkeyb.h"
extern int  (*ptr_vga_init)(void);
extern int  (*ptr_vga_setmode)(int);
extern int  (*ptr_vga_hasmode)(int);
extern void (*ptr_vga_setpage)(int);
extern vga_modeinfo * (*ptr_vga_getmodeinfo)(int);
extern unsigned char * (*ptr_vga_getgraphmem)(void);
extern int  (*ptr_vga_getmousetype)(void);
extern int  (*ptr_vga_setlinearaddressing)(void);
extern int  (*ptr_mouse_init)(char *dev, int type, int samplerate);
extern void (*ptr_mouse_close)(void);
extern int  (*ptr_mouse_update)(void);
extern void (*ptr_mouse_setposition)(int x, int y);
extern void (*ptr_mouse_setxrange)(int x1, int x2);
extern void (*ptr_mouse_setyrange)(int y1, int y2);
extern void (*ptr_mouse_setscale)(int s);
extern int  (*ptr_mouse_getx)(void);
extern int  (*ptr_mouse_gety)(void);
extern int  (*ptr_mouse_getbutton)(void);
extern int  *ptr_tty_fd;

int LinkSvgalib(void);
int LinuxStartup(int);
void UnlinkSvgalib(void);
int LinuxMemSize(int m);
int LinuxSetMode(int m, int mode, int& linear);
int LinuxInputOpen(void);
void LinuxInputClose(void);
int LinuxGetEvent(int& type, int& key, int& x, int& y, int& buttons, int ismouse);
void LinuxGraphClose(void);
extern "C" void LinuxInit(void);
extern int svgalib, nofb; // 0=ofbis; 1=svgalib
extern char fb_modename[32];
#endif
